//=====================================================================||
//                       version based on                              ||
//               NOP Design JavaScript Shopping Cart                   ||
//                                                                     ||
// For more information on SmartSystems, or how NOPDesign can help you ||
// Please visit us on the WWW at http://www.nopdesign.com              ||
//                                                                     ||
// Javascript portions of this shopping cart software are available as ||
// freeware from NOP Design.  You must keep this comment unchanged in  ||
// your code.  For more information contact FreeCart@NopDesign.com.    ||
//                                                                     ||
// JavaScript Shop Module, V.4.4.0                                     ||
//=====================================================================||

MonetarySymbol        = ' ';
DecimalSymbol         = ',';
MonetarySymbolFirst   = false;
DisplayNotice         = true;
DisplayShippingColumn = true;
DisplayShippingRow    = true;
DisplayTaxRow         = false;
TaxRate               = 0.00;
MinimumOrder          = 0.00;
MaximumOrder          = 0.00;
InitialShippingAmount = 0.00;
WeightUnit            = '';
NotApplicable         = 'N/A';

// PayPal fields parameters
PPOutputItemId        = 'item_number_';	// 'ID_';
PPOutputItemQuantity  = 'quantity_';
PPOutputItemPrice     = 'amount_';		// 'PRICE_';
PPOutputItemName      = 'item_name_';	// 'NAME_';
PPOutputItemShipping  = 'SHIPPING_';
PPOutputItemAddtlInfo = 'os0_';			// 'ADDTLINFO_';

// standard fields parametes
OutputItemId          = 'i';		// 'item_number_';
OutputItemQuantity    = 'q';		// 'quantity_'
OutputItemPrice       = 'a';		// 'amount_';
OutputItemName        = 'n';		// 'item_name';
OutputItemShipping    = 's';		// 'SHIPPING_'
OutputItemAddtlInfo   = 'o';		// 'os0_';				
OutputOrderSubtotal   = 'subtotal';			
OutputOrderShipping   = 'shipping';		
OutputOrderTax        = 'tax';
OutputOrderTotal      = 'TOTAL';

// Internal constants
AppendItemNumToOutput  = true;
HiddenFieldsToCheckout = true;
MaxItemPerOrder        = 15;
  
htmlExt                = '.html';
CatalogPath            = new Array("");
DisplayItemLinks       = false;	
	
//---------------------------------------------------------------------||
// FUNCTION:    AddMonetarySymbol                                      ||
// PARAMETERS:  string                                                 ||
// RETURNS:     string with the MonetarySymbol added in first/last pos ||
//---------------------------------------------------------------------||
function AddMonetarySymbol(strVal) {
   var strsym = "";
   if (MonetarySymbolFirst) 
      strsym = MonetarySymbol + strVal;
   else	
      strsym = strVal + MonetarySymbol;
   return(strsym);
}

//---------------------------------------------------------------------||
// FUNCTION:    CKquantity                                             ||
// PARAMETERS:  Quantity to                                            ||
// RETURNS:     Quantity as a number, and possible alert               ||
// PURPOSE:     Make sure quantity is represented as a number          ||
//---------------------------------------------------------------------||
function CKquantity(checkString) {
   var strNewQuantity = "";

   for ( i = 0; i < checkString.length; i++ ) {
      ch = checkString.substring(i, i+1);
      if ( (ch >= "0" && ch <= "9") || (ch == '.') )
         strNewQuantity += ch;
   }

   if ( strNewQuantity.length < 1 )
      strNewQuantity = "1";

   return(strNewQuantity);
}

//---------------------------------------------------------------------||
// FUNCTION:    AddToCart                                              ||
// PARAMETERS:  Form Object                                            ||
// RETURNS:     Cookie to user's browser, with prompt                  ||
// PURPOSE:     Adds a product to the user's shopping cart             ||
//---------------------------------------------------------------------||
function AddToCart(thisForm) {
   var iNumberOrdered = 0;
   var bAlreadyInCart = false;
   var notice = "";
   var bNoQtyAllowed = false;
   iNumberOrdered = GetCookie("NumberOrdered");

   if ( iNumberOrdered == null )
      iNumberOrdered = 0;

   if ( thisForm.USC == null )
      strShipCoeff = "";
   else
      strShipCoeff = thisForm.USC.value;

			if ( thisForm.ID_NUM == null )
      strID_NUM    = "";
   else
      strID_NUM    = thisForm.ID_NUM.value;

   if ( thisForm.QUANTITY == null )
   {
      strQUANTITY  = "1";
      bNoQtyAllowed = true;
   }   
   else
   {
      strQUANTITY  = thisForm.QUANTITY.value;
      bNoQtyAllowed = false;
   }
   if ( thisForm.PRICE == null )
      strPRICE     = "0.00";
   else
      strPRICE     = thisForm.PRICE.value;

   if ( thisForm.NAME == null )
      strNAME      = "";
   else
      strNAME      = thisForm.NAME.value;

   if ( thisForm.SHIPPING == null )
      strSHIPPING  = "0.00";
   else
      strSHIPPING  = thisForm.SHIPPING.value;

   if ( thisForm.ADDITIONALINFO == null ) {
      strADDTLINFO = "";
   } else {
	    var s = thisForm.ADDITIONALINFO[thisForm.ADDITIONALINFO.selectedIndex].value;
			s = s.split('^');
      strADDTLINFO = s[0];
   }
   if ( thisForm.ADDITIONALINFO2 != null ) {
	    var s = thisForm.ADDITIONALINFO2[thisForm.ADDITIONALINFO2.selectedIndex].value;
			s = s.split('^');
      strADDTLINFO += "; " + s[0];
   }
   if ( thisForm.ADDITIONALINFO3 != null ) {
	    var s = thisForm.ADDITIONALINFO3[thisForm.ADDITIONALINFO3.selectedIndex].value;
			s = s.split('^');
      strADDTLINFO += "; " + s[0];
   }
   if ( thisForm.ADDITIONALINFO4 != null ) {
	    var s = thisForm.ADDITIONALINFO4[thisForm.ADDITIONALINFO4.selectedIndex].value;
			s = s.split('^');
      strADDTLINFO += "; " + s[0];
   }
   if( bNoQtyAllowed ) 
      strADDTLINFO += "|qty=1";

   //Is this product already in the cart?  If so, increment quantity instead of adding another.
   for ( i = 1; i <= iNumberOrdered; i++ ) {
      NewOrder = "Order." + i;
      database = "";
      database = GetCookie(NewOrder);

      Token0 = database.indexOf("|", 0);
      Token1 = database.indexOf("|", Token0+1);
      Token2 = database.indexOf("|", Token1+1);
      Token3 = database.indexOf("|", Token2+1);
      Token4 = database.indexOf("|", Token3+1);
			Token5 = database.indexOf("|", Token4+1);
			
      fields = new Array;
      fields[0] = database.substring( 0, Token0 );
      fields[1] = database.substring( Token0+1, Token1 );
      fields[2] = database.substring( Token1+1, Token2 );
      fields[3] = database.substring( Token2+1, Token3 );
      fields[4] = database.substring( Token3+1, Token4 );
      fields[5] = database.substring( Token4+1, Token5 );
			fields[6] = database.substring( Token5+1, database.length );

      if ( fields[0] == strID_NUM &&
           fields[2] == strPRICE  &&
           fields[3] == strNAME   &&
           fields[6] == strADDTLINFO
         ) 
      {
         bAlreadyInCart = true;
         if ( !bNoQtyAllowed )
         {
           dbUpdatedOrder = strID_NUM    + "|" +
                          (parseInt(strQUANTITY)+parseInt(fields[1]))  + "|" +
                          strPRICE     + "|" +
                          strNAME      + "|" +
                          strSHIPPING  + "|" +
                          strShipCoeff + "|" +
                          strADDTLINFO;
           strNewOrder = "Order." + i;
           DeleteCookie(strNewOrder, "/");
           SetCookie(strNewOrder, dbUpdatedOrder, null, "/");
           notice = strQUANTITY + " " + strNAME + " " + strAdded;
         }
	     else
	         notice = strNAME + " " + strAdded;
         break;
      }
   }

   if ( !bAlreadyInCart ) 
   {
      iNumberOrdered++;

      if ( iNumberOrdered > MaxItemPerOrder )
         alert( strSorry );
      else 
      {
         dbUpdatedOrder = strID_NUM    + "|" + 
                          strQUANTITY  + "|" +
                          strPRICE     + "|" +
                          strNAME      + "|" +
                          strSHIPPING  + "|" +
                          strShipCoeff + "|" +
                          strADDTLINFO;

         strNewOrder = "Order." + iNumberOrdered;
         SetCookie(strNewOrder, dbUpdatedOrder, null, "/");
         SetCookie("NumberOrdered", iNumberOrdered, null, "/");
         if( !bNoQtyAllowed ) 
	         notice = strQUANTITY + " " + strNAME + " " + strAdded;
	     else
	         notice = strNAME + " " + strAdded;
      }
   }

   if ( DisplayNotice && notice != "" )
      alert(notice);
}

//---------------------------------------------------------------------||
// FUNCTION:    getCookieVal                                           ||
// PARAMETERS:  offset                                                 ||
// RETURNS:     URL unescaped Cookie Value                             ||
// PURPOSE:     Get a specific value from a cookie                     ||
//---------------------------------------------------------------------||
function getCookieVal (offset) {
   var endstr = document.cookie.indexOf (";", offset);

   if ( endstr == -1 )
      endstr = document.cookie.length;
   return(unescape(document.cookie.substring(offset, endstr)));
}

//---------------------------------------------------------------------||
// FUNCTION:    FixCookieDate                                          ||
// PARAMETERS:  date                                                   ||
// RETURNS:     date                                                   ||
// PURPOSE:     Fixes cookie date, stores back in date                 ||
//---------------------------------------------------------------------||
function FixCookieDate (date) {
   var base = new Date(0);
   var skew = base.getTime();

   date.setTime (date.getTime() - skew);
}

//---------------------------------------------------------------------||
// FUNCTION:    GetCookie                                              ||
// PARAMETERS:  Name                                                   ||
// RETURNS:     Value in Cookie                                        ||
// PURPOSE:     Retrieves cookie from users browser                    ||
//---------------------------------------------------------------------||
function GetCookie (name) {
   var arg = name + "=";
   var alen = arg.length;
   var clen = document.cookie.length;
   var i = 0;

   while ( i < clen ) {
      var j = i + alen;
      if ( document.cookie.substring(i, j) == arg ) return(getCookieVal (j));
      i = document.cookie.indexOf(" ", i) + 1;
      if ( i == 0 ) break;
   }

   return(null);
}

//---------------------------------------------------------------------||
// FUNCTION:    SetCookie                                              ||
// PARAMETERS:  name, value, expiration date, path, domain, security   ||
// RETURNS:     Null                                                   ||
// PURPOSE:     Stores a cookie in the users browser                   ||
//---------------------------------------------------------------------||
function SetCookie (name,value,expires,path,domain,secure) {
   document.cookie = name + "=" + escape (value) +
                     ((expires) ? "; expires=" + expires.toGMTString() : "") +
                     ((path) ? "; path=" + path : "") +
                     ((domain) ? "; domain=" + domain : "") +
                     ((secure) ? "; secure" : "");
}

//---------------------------------------------------------------------||
// FUNCTION:    DeleteCookie                                           ||
// PARAMETERS:  Cookie name, path, domain                              ||
// RETURNS:     null                                                   ||
// PURPOSE:     Removes a cookie from users browser.                   ||
//---------------------------------------------------------------------||
function DeleteCookie (name,path,domain) {
   if ( GetCookie(name) ) {
      document.cookie = name + "=" +
                        ((path) ? "; path=" + path : "") +
                        ((domain) ? "; domain=" + domain : "") +
                        "; expires=Thu, 01-Jan-70 00:00:01 GMT";
   }
}

//---------------------------------------------------------------------||
// FUNCTION:    MoneyFormat                                            ||
// PARAMETERS:  Number to be formatted                                 ||
// RETURNS:     Formatted Number                                       ||
// PURPOSE:     Reformats Dollar Amount to #.## format                 ||
//---------------------------------------------------------------------||
function moneyFormat(input, decsep) {
   var dollars = Math.floor(input);
   var tmp = new String(input);
   for ( var decimalAt = 0; decimalAt < tmp.length; decimalAt++ ) {
      if ( tmp.charAt(decimalAt)=="." )
         break;
   }
   var cents  = "" + Math.round(input * 100);
   cents = cents.substring(cents.length-2, cents.length);
   dollars += ((tmp.charAt(decimalAt+2)=="9")&&(cents=="00"))? 1 : 0;
   if ( cents.length == 1 )
      cents = "0" + cents;
   if( (decsep == null) || (decsep == "") )
     return(dollars + DecimalSymbol + cents);
   return(dollars + '.' + cents);
}

//---------------------------------------------------------------------||
// FUNCTION:    RemoveFromCart                                         ||
// PARAMETERS:  Order Number to Remove                                 ||
// RETURNS:     Null                                                   ||
// PURPOSE:     Removes an item from a users shopping cart             ||
//---------------------------------------------------------------------||
function RemoveFromCart(RemOrder) {
   if ( confirm( strRemove ) ) {
      NumberOrdered = GetCookie("NumberOrdered");
      for ( i=RemOrder; i < NumberOrdered; i++ ) {
         NewOrder1 = "Order." + (i+1);
         NewOrder2 = "Order." + (i);
         database = GetCookie(NewOrder1);
         SetCookie (NewOrder2, database, null, "/");
      }
      NewOrder = "Order." + NumberOrdered;
      SetCookie ("NumberOrdered", NumberOrdered-1, null, "/");
      DeleteCookie(NewOrder, "/");
      location.href=location.href;
   }
}

function CleanShopcart() {
  DeleteCookie( "NumberOrdered", "/" );  
	DeleteCookie( "OrderId", "/" );
}

//---------------------------------------------------------------------||
// FUNCTION:    ChangeQuantity                                         ||
// PARAMETERS:  Order Number to Change Quantity                        ||
// RETURNS:     Null                                                   ||
// PURPOSE:     Changes quantity of an item in the shopping cart       ||
//---------------------------------------------------------------------||
function ChangeQuantity(OrderItem,NewQuantity) {
   if ( isNaN(NewQuantity) ) {
      alert( strErrQty );
   } else {
      NewOrder = "Order." + OrderItem;
      database = "";
      database = GetCookie(NewOrder);

      Token0 = database.indexOf("|", 0);
      Token1 = database.indexOf("|", Token0+1);
      Token2 = database.indexOf("|", Token1+1);
      Token3 = database.indexOf("|", Token2+1);
      Token4 = database.indexOf("|", Token3+1);
      Token5 = database.indexOf("|", Token4+1);

      fields = new Array;
      fields[0] = database.substring( 0, Token0 );
      fields[1] = database.substring( Token0+1, Token1 );
      fields[2] = database.substring( Token1+1, Token2 );
      fields[3] = database.substring( Token2+1, Token3 );
      fields[4] = database.substring( Token3+1, Token4 );
      fields[5] = database.substring( Token4+1, Token5 );
      fields[6] = database.substring( Token5+1, database.length );

      dbUpdatedOrder = fields[0] + "|"+NewQuantity + "|" +fields[2] + "|" +fields[3] + "|" +fields[4] + "|" +fields[5] + "|" +fields[6];
      strNewOrder = "Order." + OrderItem;
      DeleteCookie(strNewOrder, "/");
      SetCookie(strNewOrder, dbUpdatedOrder, null, "/");
      location.href=location.href;      
   }
}

//---------------------------------------------------------------------||
// FUNCTION:    getUniqueId                                            ||
// PARAMETERS:  Null                                                   ||
// RETURNS:     a 11 character unique Id (time based)                  ||
//---------------------------------------------------------------------||
function initArray() 
{
    this.length = initArray.arguments.length;
    for (var i = 0; i < this.length; i++)
        this[i] = initArray.arguments[i];
}
function getUniqueId()
{
    var retval = '';
    var ConvArray = new initArray(0,1,2,3,4,5,6,7,8,9,'A','B','C','D','E','F');
    var intnum;
    var tmpnum;
    var i = 0;
	var value = new Date().getTime();

    intnum = parseInt(value,10);
    if (isNaN(intnum)){
        retval = 'NaN';
    }else{
        while (intnum > 0.9){
            i++;
            tmpnum = intnum;
            // cancatinate return string with new digit:
            retval = ConvArray[tmpnum % 16] + retval;  
            intnum = Math.floor(tmpnum / 16);
            if (i > 100){
                // break infinite loops
                retval = 'NaN';
                break;
            }
        }
    }
    return retval;
}

function GetFixedShippingPrice( fTotal )
{
  var i = 0;
  var aFSLimit = new initArray(0,0,0,0);
  var aFSAmount = new initArray(0,0,0,0);
  var shippingamount = aFSAmount[0];
	
  if( aFSLimit[0] > 0 || aFSAmount[0] > 0 )
  { 
	  for( i=0; i<aFSLimit.length; i++ )
	    if( aFSLimit[i] > 0 && fTotal >= aFSLimit[i] ) { shippingamount = aFSAmount[i]; }
  } 
 	return( shippingamount );
}

function GetWeightShippingPrice( fTotal )
{
  var i = 0;
  var aWSLimit = new initArray(0,0,0,0);
  var aWSAmount = new initArray(0,0,0,0);
  var shippingamount = 0.00;
	
	for( i=0; i<aWSLimit.length; i++ )
		if( aWSLimit[i] > 0 && fTotal >= aWSLimit[i] ) { shippingamount = aWSAmount[i]; }
	return( shippingamount );
}

function RemoveUnsafeChars( str )
{
  if( str != null )
    return str.replace( '\"', '\'\'' );		// replace double quotes with two simple quotes
  return null;
}

//---------------------------------------------------------------------||
// FUNCTION:    ManageCart                                             ||
// PARAMETERS:  Null                                                   ||
// RETURNS:     Product Table Written to Document                      ||
// PURPOSE:     Draws current cart product table on HTML page          ||
//---------------------------------------------------------------------||
function ManageCart( ) {
   var iNumberOrdered = 0;    //Number of products ordered
   var fTotal         = 0;    //Total cost of order
   var fTax           = 0;    //Tax amount
   var fShipping      = InitialShippingAmount;    //Shipping amount
   var fShippingWeight = 0;   //Shipping weight
   var strTotal       = "";   //Total cost formatted as money
   var strTax         = "";   //Total tax formatted as money
   var strShipping    = "";   //Total shipping formatted as money
   var strOutput      = "";   //String to be written to page
   var bDisplay       = true; //Whether to write string to the page (here for programmers)

   SetCookie("OrderId", getUniqueId(), null, "/");
   
   iNumberOrdered = GetCookie("NumberOrdered");
   if ( iNumberOrdered == null )
      iNumberOrdered = 0;

   if ( bDisplay )
      strOutput = "<center><TABLE CLASS=\"nopcart\"><TR>" +
                  "<TD CLASS=\"nopheader\"><B>"+strILabel+"</B></TD>" +
                  "<TD CLASS=\"nopheader\"><B>"+strDLabel+"</B></TD>" +
                  "<TD CLASS=\"nopheader\"><B>"+strQLabel+"</B></TD>" +
                  "<TD CLASS=\"nopheader\"><B>"+strPLabel+"</B></TD>" +
                  (DisplayShippingColumn?"<TD CLASS=\"nopheader\"><B>"+strSLabel+"</B></TD>":"") +
                  "<TD CLASS=\"nopheader\"><B>"+strRLabel+"</B></TD></TR>";

   if ( iNumberOrdered == 0 ) {
      strOutput += "<TR><TD COLSPAN=6 CLASS=\"nopentry\"><CENTER><BR><B>" + strEmptyCart + "</B><BR><BR></CENTER></TD></TR>";
   }

   for ( i = 1; i <= iNumberOrdered; i++ ) {
      NewOrder = "Order." + i;
      database = "";
      database = GetCookie(NewOrder);

      Token0 = database.indexOf("|", 0);
      Token1 = database.indexOf("|", Token0+1);
      Token2 = database.indexOf("|", Token1+1);
      Token3 = database.indexOf("|", Token2+1);
      Token4 = database.indexOf("|", Token3+1);
      Token5 = database.indexOf("|", Token4+1);

      fields = new Array;
      fields[0] = database.substring( 0, Token0 );                 // Product ID
      fields[1] = database.substring( Token0+1, Token1 );          // Quantity
      fields[2] = database.substring( Token1+1, Token2 );          // Price
      fields[3] = database.substring( Token2+1, Token3 );          // Product Name/Description
      fields[4] = database.substring( Token3+1, Token4 );          // Shipping Cost
      fields[5] = database.substring( Token4+1, Token5 ); 				 //Shipping weight
      fields[6] = database.substring( Token5+1, database.length ); //Additional Information
	  
	  bNoQtyUpdate = ( fields[6].indexOf("|qty=1", 0) >= 0 );
	  if( bNoQtyUpdate )
	  	fields[6] = fields[6].split("|qty=1")[0];

      fTotal     += (parseInt(fields[1]) * parseFloat(fields[2]) );
      fShipping  += (parseInt(fields[1]) * parseFloat(fields[4]) );
			if( fields[5] && fields[5].length > 0 )
				fShippingWeight += (parseInt(fields[1]) * parseFloat(fields[5]) )
			//      fTax        = (fTotal * TaxRate);
      strTotal    = moneyFormat(fTotal, '.');
      strTax      = moneyFormat(fTax, '.');
      strShipping = moneyFormat(fShipping, '.');

      if ( bDisplay ) 
      {
				 if( DisplayItemLinks ) 
				 {
						var url = "";
						database = fields[0];
						Token0 = database.indexOf("-", 0);
						url = CatalogPath[ eval( database.substring( 0, Token0 ) ) - 1 ];
						Token0 = eval( database.substring( Token0+1, database.length ) );
						if( (Token0 > 1) || (url.substring( url.length - 4 ) == "page" ) )
							url += Token0;
						url += htmlExt;
						strOutput += "<TR><TD CLASS=\"nopentry\">"  + fields[0] + "</TD><TD CLASS=\"nopentry\"><a href=\"" + url + "\">" + fields[3] + "</a>";
				 }
         else
					  strOutput += "<TR><TD CLASS=\"nopentry\">"  + fields[0] + "</TD><TD CLASS=\"nopentry\">" + fields[3];
				
				 if( fields[6] != "" )
 					 strOutput += " - <I>"+ fields[6] + "</I></TD>";
         strOutput += "</TD>";

		     if( !bNoQtyUpdate )
           strOutput += "<TD CLASS=\"nopentry\" align=\"center\"><INPUT TYPE=TEXT NAME=Q SIZE=2 VALUE=\"" + fields[1] + "\" onChange=\"ChangeQuantity("+i+", this.value);\"></TD>";
         else
           strOutput += "<TD CLASS=\"nopentry\" align=\"center\">" + fields[1] + "</TD>";

         strOutput += "<TD CLASS=\"nopentry\">"+ AddMonetarySymbol(moneyFormat(fields[2])) + strPerItem +"</TD>";

         if ( DisplayShippingColumn ) {
            if ( parseFloat(fields[4]) > 0 )
               strOutput += "<TD CLASS=\"nopentry\">"+ AddMonetarySymbol(moneyFormat(fields[4])) + strPerItem +"</TD>";
            else if( parseFloat(fields[5]) > 0 && WeightUnit != "" )
						{
						   var sx = parseInt(fields[1]) * parseFloat(fields[5]);
						   strOutput += "<TD CLASS=\"nopentry\">" + sx + WeightUnit + "</TD>";
						}
						else
               strOutput += "<TD CLASS=\"nopentry\">" + NotApplicable + "</TD>";
         }

         strOutput += "<TD CLASS=\"nopentry\" ALIGN=CENTER><input type=button value=\" "+strRButton+" \" onClick=\"RemoveFromCart("+i+")\" class=\"nopbutton\"></TD></TR>";
      }

      if ( AppendItemNumToOutput ) {
         strFooter = i;
      } else {
         strFooter = "";
      }
      if ( HiddenFieldsToCheckout ) {
         strOutput += "<input type=hidden name=\"" + OutputItemId        + strFooter + "\" value=\"" + fields[0] + "\">";
         strOutput += "<input type=hidden name=\"" + OutputItemQuantity  + strFooter + "\" value=\"" + fields[1] + "\">";
         strOutput += "<input type=hidden name=\"" + OutputItemPrice     + strFooter + "\" value=\"" + fields[2] + "\">";
         strOutput += "<input type=hidden name=\"" + OutputItemName      + strFooter + "\" value=\"" + fields[3] + "\">";
         strOutput += "<input type=hidden name=\"" + OutputItemShipping  + strFooter + "\" value=\"" + fields[4] + "\">";
         strOutput += "<input type=hidden name=\"" + "USC" + strFooter + "\" value=\"" + fields[5] + "\">";
         strOutput += "<input type=hidden name=\"" + OutputItemAddtlInfo + strFooter + "\" value=\"" + fields[6] + "\">";
      }

   }
   fShipping += GetFixedShippingPrice( fTotal ); 
   fShipping += GetWeightShippingPrice( fShippingWeight ); 
   g_TotalCost = (fTotal + fShipping + fTax);
   if ( bDisplay ) {
      strOutput += "<TR><TD align='right' CLASS=\"noptotal\" COLSPAN=4><B>"+strSUB+"&nbsp;</B></TD>";
      strOutput += "<TD align='right' CLASS=\"noptotal\" COLSPAN=2><B>" + AddMonetarySymbol(moneyFormat(fTotal)) + "</B></TD>";
      strOutput += "</TR>";

      if ( DisplayShippingRow ) {
         // moneyFormat(fShippingWeight)+" "+WeightUnit  
				 strOutput += "<TR><TD align='right' CLASS=\"noptotal\" COLSPAN=4><B>"+strSHIP+"&nbsp;</B></TD>";
         strOutput += "<TD align='right' CLASS=\"noptotal\" COLSPAN=2><B>" + AddMonetarySymbol(moneyFormat(fShipping)) + "</B></TD>";
         strOutput += "</TR>";
      }

      if ( DisplayTaxRow ) {
         strOutput += "<TR><TD align='right' CLASS=\"noptotal\" COLSPAN=4><B>"+strTAX+"&nbsp;</B></TD>";
         strOutput += "<TD align='right' CLASS=\"noptotal\" COLSPAN=2><B>" + AddMonetarySymbol(moneyFormat(fTax)) + "</B></TD>";
         strOutput += "</TR>";
      }

      strOutput += "<TR><TD align='right' CLASS=\"noptotal\" COLSPAN=4><B>"+strTOT+"&nbsp;</B></TD>";
      strOutput += "<TD align='right' CLASS=\"noptotal\" COLSPAN=2><B>" + AddMonetarySymbol(moneyFormat(g_TotalCost)) + "</B></TD>";
      strOutput += "</TR>";
      strOutput += "</TABLE></center>";

      if ( HiddenFieldsToCheckout ) {
         strOutput += "<input type=\"hidden\" name=\""+OutputOrderSubtotal+"\" value=\""+ strTotal + "\">";
         strOutput += "<input type=\"hidden\" name=\""+OutputOrderShipping+"\" value=\""+ moneyFormat(fShipping, '.') + "\">";
//         strOutput += "<input type=\"hidden\" name=\"shipping\" value=\""+ moneyFormat(fShipping, '.') + "\">";
//         strOutput += "<input type=\"hidden\" name=\"shipping2\" value=\""+ moneyFormat(fShipping, '.') + "\">";
//         strOutput += "<input type=\"hidden\" name=\""+OutputOrderTax+"\"      value=\""+ strTax + "\">";
         strOutput += "<input type=\"hidden\" name=\""+OutputOrderTotal+"\"    value=\""+ moneyFormat(g_TotalCost, '.') + "\">";
      }
   }
   
   document.write(strOutput);
   document.close();
}

/*
function DisplayBillingInfo() {
   var strOutput = GetCookie("OrderComment");
   document.open();
   if (!strOutput) {
      document.writeln( "<p>" + strNoComment + "</p>" );
   } else
   {
      document.writeln( "<p>" + strOutput + "</p>" );
      document.writeln( "<input type=hidden name=\"comment\"    value=\""+ strOutput + "\">" );
   }
   document.close();
}

function GetOrderAmount( excludeShipping )
{
  var amount = "";
  if( excludeShipping == 1 ) {
    amount = GetCookie("OrderSubtotal");
  } else
  	amount = GetCookie("OrderTotal");
  return( amount );
}
*/

//---------------------------------------------------------------------||
// FUNCTION:    ValidateCart                                           ||
// PARAMETERS:  Form to validate                                       ||
// RETURNS:     true/false                                             ||
// PURPOSE:     Validates the managecart form                          ||
//---------------------------------------------------------------------||
var g_TotalCost = 0;
function ValidateCart( theForm ) {
   if ( MinimumOrder >= 0.01 ) {
      if ( g_TotalCost < MinimumOrder ) {
         alert( MinimumOrderPrompt );
         return false;
      }
   }
   if ( MaximumOrder >= 0.01 ) {
      if ( g_TotalCost > MaximumOrder ) {
         alert( MaximumOrderPrompt );
         return false;
      }
   }
   SetCookie("OrderTotal", theForm.TOTAL.value, null, "/");
//   SetCookie("OrderSubtotal", theForm.subtotal.value, null, "/");
   return true;
}

//---------------------------------------------------------------------||
// FUNCTION:    CheckoutCart                                           ||
// PARAMETERS:  Null                                                   ||
// RETURNS:     Product Table Written to Document                      ||
// PURPOSE:     Draws current cart product table on HTML page for      ||
//              checkout.                                              ||
//---------------------------------------------------------------------||
function CheckoutCart( bHide, paypalcart ) {
   var iNumberOrdered = 0;    //Number of products ordered
   var fTotal         = 0;    //Total cost of order
   var fTax           = 0;    //Tax amount
   var fShipping      = InitialShippingAmount;    //Shipping amount
   var fShippingWeight = 0;   // Shipping weight
   var strTotal       = "";   //Total cost formatted as money
   var strTax         = "";   //Total tax formatted as money
   var strShipping    = "";   //Total shipping formatted as money
   var strOutput      = "";   //String to be written to page
   var strPP          = "";   //Payment Processor Description Field
   var bDisplay 	  = (bHide != true);

   iNumberOrdered = GetCookie("NumberOrdered");
   if ( iNumberOrdered == null )
      iNumberOrdered = 0;

   if ( bDisplay )
      strOutput = "<TABLE CLASS=\"nopcart\"><TR>" +
                  "<TD CLASS=\"nopheader\"><B>"+strILabel+"</B></TD>" +
                  "<TD CLASS=\"nopheader\"><B>"+strDLabel+"</B></TD>" +
                  "<TD CLASS=\"nopheader\"><B>"+strQLabel+"</B></TD>" +
                  "<TD CLASS=\"nopheader\"><B>"+strPLabel+"</B></TD>" +
                  (DisplayShippingColumn?"<TD CLASS=\"nopheader\"><B>"+strSLabel+"</B></TD>":"") +
                  "</TR>";

   for ( i = 1; i <= iNumberOrdered; i++ ) {
      NewOrder = "Order." + i;
      database = "";
      database = GetCookie(NewOrder);

      Token0 = database.indexOf("|", 0);
      Token1 = database.indexOf("|", Token0+1);
      Token2 = database.indexOf("|", Token1+1);
      Token3 = database.indexOf("|", Token2+1);
      Token4 = database.indexOf("|", Token3+1);
      Token5 = database.indexOf("|", Token4+1);

      fields = new Array;
      fields[0] = database.substring( 0, Token0 );                 // Product ID
      fields[1] = database.substring( Token0+1, Token1 );          // Quantity
      fields[2] = database.substring( Token1+1, Token2 );          // Price
      fields[3] = RemoveUnsafeChars( database.substring( Token2+1, Token3 ) );          // Product Name/Description
      fields[4] = database.substring( Token3+1, Token4 );          // Shipping Cost
      fields[5] = database.substring( Token4+1, Token5 );          // Shipping Cost
      fields[6] = RemoveUnsafeChars( database.substring( Token5+1, database.length ) ); //Additional Information
	    fields[6] = fields[6].split("|qty=1")[0]; // remove quantity flag info (use only to indicate that quantity is fixed to 1)

      fTotal     += (parseInt(fields[1]) * parseFloat(fields[2]) );
      fShipping  += (parseInt(fields[1]) * parseFloat(fields[4]) );
			if( fields[5] && fields[5].length > 0 )
				fShippingWeight += (parseInt(fields[1]) * parseFloat(fields[5]) );
//      fTax = (fTotal * TaxRate);
      strTotal    = moneyFormat(fTotal, '.');
      strTax      = moneyFormat(fTax, '.');

      if ( bDisplay ) {
         strOutput += "<TR><TD CLASS=\"nopentry\">"  + fields[0] + "</TD>";

         if ( fields[6] == "" )
            strOutput += "<TD CLASS=\"nopentry\">"  + fields[3] + "</TD>";
         else
            strOutput += "<TD CLASS=\"nopentry\">"  + fields[3] + " - <I>"+ fields[6] + "</I></TD>";

         strOutput += "<TD CLASS=\"nopentry\">" + fields[1] + "</TD>";
         strOutput += "<TD CLASS=\"nopentry\">"+ AddMonetarySymbol(moneyFormat(fields[2])) + strPerItem +"</TD>";

         if ( DisplayShippingColumn ) {
            if ( parseFloat(fields[4]) > 0 )
               strOutput += "<TD CLASS=\"nopentry\">"+ AddMonetarySymbol(moneyFormat(fields[4])) + strPerItem +"</TD>";
            else if( parseFloat(fields[5]) > 0 && WeightUnit != "" )
						{
						   var sx = parseInt(fields[1]) * parseFloat(fields[5]);
						   strOutput += "<TD CLASS=\"nopentry\">" + sx + WeightUnit + "</TD>";
						}
						else
               strOutput += "<TD CLASS=\"nopentry\">" + NotApplicable + "</TD>";
				 }
         strOutput += "</TR>";
      }

      if ( AppendItemNumToOutput ) {
         strFooter = i;
      } else {
         strFooter = "";
      }
      strOutput += "<input type=hidden name=\"" + ((paypalcart)?PPOutputItemId:OutputItemId) + strFooter + "\" value=\"" + fields[0] + "\">";
      strOutput += "<input type=hidden name=\"" + ((paypalcart)?PPOutputItemQuantity:OutputItemQuantity) + strFooter + "\" value=\"" + fields[1] + "\">";
      strOutput += "<input type=hidden name=\"" + ((paypalcart)?PPOutputItemPrice:OutputItemPrice) + strFooter + "\" value=\"" + fields[2] + "\">";
      strOutput += "<input type=hidden name=\"" + ((paypalcart)?PPOutputItemName:OutputItemName) + strFooter + "\" value=\"" + fields[3] + "\">";
      strOutput += "<input type=hidden name=\"" + ((paypalcart)?PPOutputItemShipping:OutputItemShipping) + strFooter + "\" value=\"" + fields[4] + "\">";
      if( bHide && fields[6] != "" ) // Paypal
      {
      	strOutput += "<input type=hidden name=\"" + ((paypalcart)?PPOutputItemAddtlInfo:OutputItemAddtlInfo) + strFooter + "\" value=\"" + fields[6] + "\">";
      	strOutput += "<input type=hidden name=\"on0_" + strFooter + "\" value=\"Info\">";
      }
   }
   fShipping  += GetFixedShippingPrice( fTotal ); 
   fShipping += GetWeightShippingPrice( fShippingWeight ); 

   strShipping = moneyFormat(fShipping, '.');
   if( paypalcart )
     strOutput += "<input type=hidden name=\"shipping_1\" value=\"" + strShipping + "\">";
     
   if ( bDisplay ) {
      strOutput += "<TR><TD align='right' CLASS=\"noptotal\" COLSPAN=3><B>"+strSUB+"&nbsp;</B></TD>";
      strOutput += "<TD align='right' CLASS=\"noptotal\" COLSPAN='2'><B>" + AddMonetarySymbol(moneyFormat(fTotal)) + "</B></TD>";
      strOutput += "</TR>";

      if ( DisplayShippingRow ) {
         strOutput += "<TR><TD align='right' CLASS=\"noptotal\" COLSPAN=3><B>"+strSHIP+"&nbsp;</B></TD>";
         strOutput += "<TD align='right' CLASS=\"noptotal\" COLSPAN='2'><B>" + AddMonetarySymbol(moneyFormat(fShipping)) + "</B></TD>";
         strOutput += "</TR>";
      }

      if ( DisplayTaxRow ) {
         strOutput += "<TR><TD align='right' CLASS=\"noptotal\" COLSPAN=3><B>"+strTAX+"&nbsp;</B></TD>";
         strOutput += "<TD align='right' CLASS=\"noptotal\" COLSPAN='2'><B>" + AddMonetarySymbol(moneyFormat(fTax)) + "</B></TD>";
         strOutput += "</TR>";
      }

      strOutput += "<TR><TD align='right' CLASS=\"noptotal\" COLSPAN=3><B>"+strTOT+"&nbsp;</B></TD>";
      strOutput += "<TD align='right' CLASS=\"noptotal\" COLSPAN='2'><B>" + AddMonetarySymbol(moneyFormat((fTotal + fShipping + fTax))) + "</B></TD>";
      strOutput += "</TR>";

      strOutput += "</TABLE>";
      
   }
   g_TotalCost = fTotal + fShipping + fTax;	
   strOutput += "<input type=\"hidden\" name=\""+OutputOrderSubtotal+"\" value=\""+ strTotal + "\">";
   strOutput += "<input type=\"hidden\" name=\""+OutputOrderShipping+"\" value=\""+ strShipping + "\">";
//   strOutput += "<input type=\"hidden\" name=\""+OutputOrderTax+"\" value=\""+ strTax + "\">";
   strOutput += "<input type=\"hidden\" name=\""+OutputOrderTotal+"\" value=\""+ moneyFormat(g_TotalCost, '.') + "\">";
   document.write(strOutput);
   document.close();
}

function showElement( e, bshow )
{
  if ( e )  {
    if( bshow ) {
   	  e.style.visibility='visible'; 
      e.style.display='block';
    } else {
      e.style.visibility='hidden';
      e.style.display='none';
    }
  }
}

function DisplayItemInfo( nid, a1, a2, a3 )
{
  var e,s,t,nx,idx,i;
  var asel = new Array;
  asel[0] = 0;  
  asel[1] = (a1>0)?0:-1;  
  asel[2] = (a2>0)?0:-1;
  asel[3] = (a3>0)?0:-1;  
    
  for( i=1; i<=3; i++ )
  if( asel[i] >= 0 )
	{	
	  e = document.getElementById( nid + '-' + i );
    if ( e ) {
			s = e.value.split('^');
			if( s[1] )
 	      asel[ i ] = parseInt(s[1],10);
 	  }
  }
  idx = 0.0;
	//alert('color=' + asel[1] + ' size=' + asel[2] + ' type=' + asel[3]);
  if ( asel[1] >= 0 ) {
	  if ( asel[2] >= 0 ) {
	    if ( asel[3] >= 0 ) {
        idx = asel[1] + (a1 * asel[2]) + (a2 * a1 * asel[3]);
      } else
        idx = asel[1] + (a1 * asel[2]);
	  } else {
	    if ( asel[3] >= 0 ) {
        idx = asel[1] + (a1 * asel[3]);
      } else
        idx = asel[1];
    }
  } else {
	if ( asel[2] >= 0 ) {
    if ( asel[3] >= 0 ) {
      idx = asel[2] + (a2 * asel[3]);
    } else
      idx = asel[2];
	} else
	  idx = asel[3];
  }
  
  s = nid.split('-');
  nx = parseInt(s[1],10) - 1; // get item index
  for( i=0; i<catprices[nx].length; i++ ) 
  {  
    e = document.getElementById( nid + '-p' + i );
    if ( e ) 
      showElement( e, (i == idx) ); 
    e = document.getElementById( nid + '-s' + i );
    if ( e ) 
      showElement( e, (i == idx) ); 
  }
  e = document.getElementById( nid + '-price' );
  if ( e )
	{
    e.value = catprices[nx][idx];
	}
  e = document.getElementById( nid + '-ship' );
  if ( e )
	{
    e.value = catshippings[nx][idx];
	}
	else
	{
    e = document.getElementById( nid + '-weight' );
    if ( e )
      e.value = catshippings[nx][idx];
	}
}
